# Copyright 2011 by sm4rt (No it's TIG one in fact)

# THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.

# Name :          Dynamic Component Loader 0.1.1rc1
# Description :   load full libraries of components you often use by creating a menu list of your component libraries
#			inside the Sketchup Plugins Menu
# Author :        sm4rt but TIG
# Usage :         Simply edit/add the name you want to give for your component libraries inside "librariesNames" declaration
#			edit/add the corresponding folder path inside "librariesFolders" declaration
#			And that's it !
#			you'll no longer have to search through your disk to find model you usually use
#			Just feed your model libs as time goes by
#			Script will load sub-folders too
# Date :          8.Apr.2011
# Type :		Loader
# History:
#			0.1.1rc1 (8.Apr.2011) - impressive fully versatile revision
#			0.1.1beta1 (7.Apr.2011) - loud dirty unefficient version


require 'sketchup.rb'
#order = ["Components", "MyLibrary"]
librariesNames = ["MyLibrary", "Components"]
librariesFolders = { "Components" => "../Components", "MyLibrary" => "../MyLibrary"}
module Sm4rt_CL
 class List_Menu_Load
  def initialize(rep=nil, menu=nil)
    return nil if not rep or not menu or not File.exist?(rep) or not File.ftype(rep)=='directory'
    skps=[]; folders=[]
    Dir.entries(rep).each{|f|
      next if f=='.' or f=='..'
      path=File.join(rep, f)
      skps << f if File.ftype(path)!='directory' and File.extname(f).downcase=='.skp'
      folders << f if File.ftype(path)=='directory'
    }
    folders.each{|folder|
      path=File.join(rep, folder); smenu=menu.add_submenu(folder)
      Sm4rt_CL::List_Menu_Load.new(path, smenu) if smenu
    }
     skps.each{|skp|
      skpc=File.basename(skp, ".*"); path=File.join(rep, skp)
      menu.add_item(skpc){Sm4rt_CL::List_Menu_Load::component_loader(path)}
    }
 end#initialize
  def List_Menu_Load::component_loader(path=nil)
    Sketchup.active_model.import(path, true) if path
  end#component_loader
  def List_Menu_Load::menu_maker(folder=nil, name=nil)
    return nil if not folder or not name
    Sm4rt_CL::List_Menu_Load.new(File.join(File.dirname(__FILE__), folder), menu=UI.menu("Plugins").add_submenu(name))
  end#menu_maker
 end#class
end#module
### auto-run at startup
librariesNames.each {|value| Sm4rt_CL::List_Menu_Load::menu_maker(librariesFolders[value], value)}
###   